;;; Generated by Guile-SMC 0.6.3
;;; <https://github.com/artyom-poptsov/guile-smc>


;;; This finite-state machine is produced by:
;;;   PlantUML <https://plantuml.com> Reader Finite-State Machine.
;;;   This FSM is a part of Guile State-Machine Compiler (Guile-SMC)
;;;   <https://github.com/artyom-poptsov/guile-smc>
;;;
;;; Statistics:
;;;   step-counter:               398
;;;   transition-counter:          86
;;;
;;; Resolver status:
;;;   #<directory (context)>
;;;     #<<generic> event-source (1)>
;;;     #<procedure #{guard:#t}# (ctx event)>
;;;     #<procedure action:count (ctx char)>
;;;     #<procedure action:no-op (ctx event)>
;;;     #<procedure action:validate (ctx char)>
;;;     #<procedure char:double-quote? (ctx ch2)>
;;;     #<procedure char:eof-object? (ctx ch)>
;;;     #<procedure char:newline? (ctx ch2)>
;;;     #<procedure char:semicolon? (ctx ch2)>

(define-module
  (custom-fsm)
  #:use-module
  (oop goops)
  #:use-module
  (logging logger)
  #:use-module
  (logging rotating-log)
  #:use-module
  (scheme documentation)
  #:use-module
  (ice-9 textual-ports)
  #:use-module
  (context)
  #:export
  (<custom-fsm>
    fsm-run!
    fsm-debug-mode?
    fsm-debug-mode-set!))


(define-class
  <custom-fsm>
  ()
  (debug-mode?
    #:init-value
    #f
    #:init-keyword
    #:debug-mode?
    #:getter
    fsm-debug-mode?
    #:setter
    fsm-debug-mode-set!))


(define %logger-binary "/usr/bin/logger")

(define-macro-with-docs
  (define-method-with-docs
    name-and-args
    docs
    .
    body)
  "Define a method with documentation."
  `(begin
     (define-method ,name-and-args ,@body)
     (set-object-property!
       ,(car name-and-args)
       'documentation
       ,docs)
     *unspecified*))

(define-with-docs
  %default-port-log-file
  "The full path to the default log file used with <precise-port-log>."
  "/var/log/smc.log")

(define-with-docs
  %default-guile-smc-syslog-tag
  "The default syslog tag used for Guile-SMC."
  "guile-smc")

(define-class-with-docs
  <precise-logger>
  (<logger>)
  "Guile-SMC precise logger that prints log with microsecond accuracy.")

(define (log-level-enabled? lgr lvl)
  "Check if a log level LVL is enabled for a logger LGR."
  (hashq-ref (slot-ref lgr 'levels) lvl #t))

(define-method
  (%precise-log-helper
    (self <precise-logger>)
    level
    objs)
  (when (log-level-enabled? self level)
        (let ((cur-time (gettimeofday)))
          (for-each
            (lambda (str)
              (unless
                (string-null? str)
                (for-each
                  (lambda (handler)
                    (accept-log handler level cur-time str))
                  (slot-ref self 'log-handlers))))
            (string-split
              (with-output-to-string
                (lambda ()
                  (for-each (lambda (o) (display o)) objs)))
              #\newline)))))

(define-method
  (log-msg (lgr <precise-logger>) lvl . objs)
  (%precise-log-helper lgr lvl objs))

(define-class-with-docs
  <null-log>
  (<log-handler>)
  "A log handler that discards all the log messages.")

(define-method-with-docs
  (accept-log (log <null-log>) level time str)
  "This method discards all the parameters and always return #t."
  #t)

(define-class-with-docs
  <system-log>
  (<log-handler>)
  "This is a log handler which writes logs to the syslog."
  (logger
    #:init-value
    %logger-binary
    #:getter
    syslog-handler-logger)
  (tag #:init-keyword
       #:tag
       #:getter
       syslog-handler-tag)
  (use-stderr?
    #:init-value
    #f
    #:init-keyword
    #:use-stderr?
    #:getter
    syslog-handler-use-stderr?
    #:setter
    syslog-handler-use-stderr!))

(define-method
  (accept-log (log <system-log>) level time str)
  (let* ((command
           (format
             #f
             "~a -p 'user.~a' -t '~a' '~a'"
             (syslog-handler-logger log)
             level
             (syslog-handler-tag log)
             str))
         (result (system command)))
    (unless
      (zero? result)
      (error "Could not log a message"))))

(define-class-with-docs
  <precise-port-log>
  (<log-handler>)
  "Microsecond version of <port-log> from (logging port-log)."
  (port #:init-keyword
        #:port
        #:init-value
        #f
        #:accessor
        port))

(define (%precise-log-formatter lvl time str)
  (with-output-to-string
    (lambda ()
      (display
        (strftime "%F %H:%M:%S" (localtime (car time))))
      (display ".")
      (format #t "~6,'0d" (cdr time))
      (display " (")
      (display (symbol->string lvl))
      (display "): ")
      (display str)
      (newline))))

(define-method
  (initialize (self <precise-port-log>) args)
  (next-method)
  (slot-set!
    self
    'formatter
    %precise-log-formatter))

(define-method
  (emit-log (self <precise-port-log>) str)
  (display str (port self)))

(define-method
  (flush-log (self <precise-port-log>))
  (force-output (port self)))

(define-method
  (close-log! (self <precise-port-log>))
  (close-port (port self))
  (set! (port self) (%make-void-port "w")))

(define-class-with-docs
  <stderr-log>
  (<log-handler>)
  "A log handler that logs to the stderr stream."
  (port #:init-keyword
        #:port
        #:init-value
        #f
        #:accessor
        port))

(define-method
  (initialize (self <stderr-log>) args)
  (next-method)
  (slot-set! self 'port (current-error-port))
  (slot-set!
    self
    'formatter
    %precise-log-formatter))

(define-method
  (emit-log (self <stderr-log>) str)
  (display str (port self)))

(define-method
  (flush-log (self <stderr-log>))
  (force-output (port self)))

(define-method
  (close-log! (self <stderr-log>))
  (set! (port self) (%make-void-port "w")))

(define-with-docs
  %logger
  "Default logger instance for Guile-SMC."
  (make <precise-logger>))

(set-default-logger! %logger)

(register-logger!
  %default-guile-smc-syslog-tag
  %logger)

(open-log! %logger)

(define-method
  (log-add-handler! (handler <log-handler>))
  (add-handler! %logger handler))

(define-method
  (log-remove-handler! type)
  "Remove a log handler of the specified TYPE."
  (slot-set!
    %logger
    'log-handlers
    (filter
      (lambda (handler) (not (is-a? handler type)))
      (slot-ref %logger 'log-handlers))))

(define-method
  (log-clear-handlers!)
  (slot-set! %logger 'log-handlers '()))

(define-method-with-docs
  (log-use-stderr! (value <boolean>))
  "Enable or disable logging to stderr."
  (if value
    (log-add-handler! (make <stderr-log>))
    (log-remove-handler! <stderr-log>)))

(define-method
  (smc-log-init!
    (driver <string>)
    (options <list>))
  "Initialize Guile-SMC logging facilities.  @var{driver} must be either 'syslog',\n'file' or 'null', otherwise an error will be thrown.  @var{options} must be an\nassociative list of log options."
  (log-clear-handlers!)
  (let ((use-stderr?
          (let ((value (assoc-ref options 'stderr)))
            (and value
                 (cond ((string=? value "true") #t)
                       ((string=? value "false") #f)
                       (else
                        (error "Unknown value for \"stderr\" log option"
                               options)))))))
    (log-use-stderr! use-stderr?))
  (cond ((string=? driver "syslog")
         (log-add-handler!
           (make <system-log>
                 #:tag
                 %default-guile-smc-syslog-tag)))
        ((string=? driver "file")
         (let* ((file (or (assoc-ref options 'file)
                          %default-port-log-file))
                (port (open-output-file file)))
           (log-add-handler!
             (make <precise-port-log> #:port port))))
        ((string=? driver "null")
         (log-add-handler! (make <null-log>)))
        (else
         (error "Unknown log driver" driver options))))

(smc-log-init! "syslog" '())

(define (smc-log level fmt . args)
  (let ((message (apply format #f fmt args)))
    (log-msg %logger level message)))

(define (log-debug fmt . args)
  "Log a formatted debug message."
  (apply smc-log 'DEBUG fmt args))

(define (action:no-op ctx event)
  "The action that does nothing special, just returns the context CTX as it is."
  ctx)

(define (#{guard:#t}# ctx event)
  "This guard is always returns #t."
  #t)

(define-syntax-rule
  (char:make-guard name ch1)
  (begin
    (define (name ctx ch2) (char=? ch1 ch2))
    (export name)))

(char:make-guard char:double-quote? #\")

(char:make-guard char:semicolon? #\;)

(char:make-guard char:newline? #\newline)

(define-public (char:eof-object? ctx ch)
  (eof-object? ch))



(define-method
  (fsm-run! (fsm <custom-fsm>) context)
  ""
  (define (DEFAULT context)
    "Count parenthesis."
    (let ((event (event-source context)))
      (cond ((char:eof-object? context event)
             (let ((context (action:validate context event)))
               (log-debug "[~a] -> [*]" 'DEFAULT)
               context))
            ((char:semicolon? context event)
             (let ((context (action:no-op context event)))
               (log-debug "[~a] -> [~a]" 'DEFAULT 'COMMENT)
               (COMMENT context)))
            ((char:double-quote? context event)
             (let ((context (action:no-op context event)))
               (log-debug "[~a] -> [~a]" 'DEFAULT 'STRING)
               (STRING context)))
            ((#{guard:#t}# context event)
             (let ((context (action:count context event)))
               (DEFAULT context))))))
  (define (STRING context)
    "Skip a string."
    (let ((event (event-source context)))
      (cond ((char:double-quote? context event)
             (let ((context (action:no-op context event)))
               (log-debug "[~a] -> [~a]" 'STRING 'DEFAULT)
               (DEFAULT context)))
            ((#{guard:#t}# context event)
             (let ((context (action:no-op context event)))
               (STRING context))))))
  (define (COMMENT context)
    "Skip a comment."
    (let ((event (event-source context)))
      (cond ((char:newline? context event)
             (let ((context (action:no-op context event)))
               (log-debug "[~a] -> [~a]" 'COMMENT 'DEFAULT)
               (DEFAULT context)))
            ((#{guard:#t}# context event)
             (let ((context (action:no-op context event)))
               (COMMENT context))))))
  (DEFAULT context))


;;; custom-fsm ends here.
